  MEMBER

  INCLUDE('JSDEEP.INC')

  MAP
  END

JSDeepAssigner.Construct      PROCEDURE

    CODE
        
        SELF.fp &= NEW FieldPairsClass
        SELF.SourceLabels &= NEW JSDeepLabelQ
        SELF.TargetLabels &= NEW JSDeepLabelQ

JSDeepAssigner.Destruct       PROCEDURE

    CODE

    SELF.fp.Kill
        DISPOSE(SELF.fp)
        SELF.FreeLabelQ(SELF.SourceLabels)
        DISPOSE(SELF.SourceLabels)
        SELF.FreeLabelQ(SELF.TargetLabels)
        DISPOSE(SELF.TargetLabels)

        
JSDeepAssigner.INIT   PROCEDURE(*GROUP pG1,STRING pPrefix1,*GROUP pG2,STRING pPrefix2)

    CODE
    SELF.SetSourceStructure(pG1,pPrefix1)
    SELF.SetTargetStructure(pG2,pPrefix2)
    Return SELF.MatchLabels()

JSDeepAssigner.FreeLabelQ   PROCEDURE(JSDeepLabelQ pLabelQ)

    CODE
        
    LOOP
        GET(pLabelQ,1)
        If ERRORCODE()
            BREAK
        END
        pLabelQ.Field &= NULL
        Delete(pLabelQ)
    END


        
JSDeepAssigner.INIT   PROCEDURE(*QUEUE pQ1,STRING pPrefix1,*QUEUE pQ2,STRING pPrefix2)

    CODE
 
    SELF.SetSourceStructure(pQ1,pPrefix1)
    SELF.SetTargetStructure(pQ2,pPrefix2)
    Return SELF.MatchLabels()

        
JSDeepAssigner.Assign PROCEDURE

    CODE
  
  SELF.fp.AssignLeftToRight
 

  
JSDeepAssigner.SetSourceStructure      PROCEDURE(*GROUP pSourceStruct,String pPrefix)
A1                      ANY
A2                      ANY
Ndx1                    LONG
    CODE

        FREE(SELF.SourceLabels)
        Ndx1 = 0
        LOOP
            Ndx1 += 1
            A1 &= WHAT(pSourceStruct,Ndx1)
            If A1 &= NULL
                BREAK
            END
            CLEAR(SELF.SourceLabels)
            SELF.SourceLabels.Label = WHO(pSourceStruct,Ndx1)
            SELF.SourceLabels.Label = SUB(SELF.SourceLabels.Label,LEN(Clip(pPrefix))+1,Len(SELF.SourceLabels.Label))
            SELF.SourceLabels.Field &= A1
            ADD(SELF.SourceLabels) 
        END 
        

JSDeepAssigner.SetTargetStructure   PROCEDURE(*GROUP pTargetStruct,String pPrefix)
A1                      ANY
A2                      ANY
Ndx1                    LONG
    CODE

        FREE(SELF.TargetLabels)
        Ndx1 = 0
        LOOP
            Ndx1 += 1
            A1 &= WHAT(pTargetStruct,Ndx1)
            If A1 &= NULL
                BREAK
            END
            CLEAR(SELF.TargetLabels)
            SELF.TargetLabels.Label = WHO(pTargetStruct,Ndx1)
            SELF.TargetLabels.Label = SUB(SELF.TargetLabels.Label,LEN(Clip(pPrefix))+1,Len(SELF.TargetLabels.Label))
            SELF.TargetLabels.Field &= A1
            ADD(SELF.TargetLabels) 
        END 

JSDeepAssigner.SetSourceStructure      PROCEDURE(*QUEUE pSourceStruct,String pPrefix)
A1                      ANY
A2                      ANY
Ndx1                    LONG
    CODE

        FREE(SELF.SourceLabels)
        Ndx1 = 0
        LOOP
            Ndx1 += 1
            A1 &= WHAT(pSourceStruct,Ndx1)
            If A1 &= NULL
                BREAK
            END
            CLEAR(SELF.SourceLabels)
            SELF.SourceLabels.Label = WHO(pSourceStruct,Ndx1)
            SELF.SourceLabels.Label = SUB(SELF.SourceLabels.Label,LEN(Clip(pPrefix))+1,Len(SELF.SourceLabels.Label))
            SELF.SourceLabels.Field &= A1
            ADD(SELF.SourceLabels) 
        END 
        

JSDeepAssigner.SetTargetStructure   PROCEDURE(*QUEUE pTargetStruct,String pPrefix)
A1                      ANY
A2                      ANY
Ndx1                    LONG
    CODE

        FREE(SELF.TargetLabels)
        Ndx1 = 0
        LOOP
            Ndx1 += 1
            A1 &= WHAT(pTargetStruct,Ndx1)
            If A1 &= NULL
                BREAK
            END
            CLEAR(SELF.TargetLabels)
            SELF.TargetLabels.Label = WHO(pTargetStruct,Ndx1)
            SELF.TargetLabels.Label = SUB(SELF.TargetLabels.Label,LEN(Clip(pPrefix))+1,Len(SELF.TargetLabels.Label))
            SELF.TargetLabels.Field &= A1
            ADD(SELF.TargetLabels) 
        END 
        
JSDeepAssigner.MatchLabels  PROCEDURE
Ndx1                            LONG
MatchCount                      LONG

    CODE

        MatchCount = 0
        SELF.fp.Init 
        LOOP Ndx1 = 1 to Records(SELF.TargetLabels)
            GET(SELF.TargetLabels,Ndx1)
            SELF.SourceLabels.Label = SELF.TargetLabels.Label
            Get(SELF.SourceLabels,Self.SourceLabels.Label)
            If NOT ErrorCode()
                MatchCount += 1
                SELF.fp.AddPair(SELF.SourceLabels.Field,SELF.TargetLabels.Field)
            END
        END
        RETURN MatchCount